<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/language.oop5.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'pt_BR',
  ),
  'this' => 
  array (
    0 => 'language.oop5.autoload.php',
    1 => 'Autocarregamento de Classes',
  ),
  'up' => 
  array (
    0 => 'language.oop5.php',
    1 => 'Classes e Objetos',
  ),
  'prev' => 
  array (
    0 => 'language.oop5.constants.php',
    1 => 'Constantes de Classe',
  ),
  'next' => 
  array (
    0 => 'language.oop5.decon.php',
    1 => 'Construtores e Destrutores',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'pt_BR',
    'path' => 'language/oop5/autoload.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.oop5.autoload" class="sect1">
  <h2 class="title">Autocarregamento de Classes</h2>
  <p class="para">
   Muitos programadores, ao desenvolver aplicações orientadas a objeto, criam
   um arquivo PHP para cada definição de classe. Um dos maiores contratempos é
   ter de escrever uma longa lista de &quot;includes&quot; no início de cada script (um
   para cada classe).
  </p>
  <p class="para">
   A função <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span> registra qualquer número de
   autocarregadores, permitindo que classes e interfaces sejam automaticamente carregadas
   se elas não ainda não tiverem sido definidas. Ao registrar autocarregadores, o PHP tem uma última chance
   de carregar classes e interfaces antes que falhem com um erro.
  </p>
  <p class="para">
   Qualquer construção semelhante a uma classe pode ser carregada automaticamente da mesma maneira. Isso inclui classes,
   interfaces, traits e enumerações.
  </p>
  <div class="caution"><strong class="caution">Cuidado</strong>
   <p class="para">
    Antes do PHP 8.0.0, era possível usar <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span>
    para fazer autocarregamento de classes and interfaces. No entanto, ela é uma alternativa menos
    flexível a <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span> e
    <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span> está descontinuada a partir do PHP 7.2.0, e removida
    a partir do PHP 8.0.0.
   </p>
  </div>
  <blockquote class="note"><p><strong class="note">Nota</strong>: 
   <p class="para">
    <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span> pode ser chamada várias vezes para
    registrar múltiplos autocarregadores. No entando, lançar uma exceção em uma função de autocarregamento
    interromperá esse processo e não permitirá que outras funções de autocarregamento sejam
    executadas. Por esse motivo, o lançamento de exceções em funções de autocarregamento é altamente
    desencorajado.
   </p>
  </p></blockquote>
  <p class="para">
   <div class="example" id="example-242">
    <p><strong>Exemplo #1 Exemplo de autocarregamento</strong></p>
    <div class="example-contents"><p>
     Esse exemplo tenta carregar as classes <code class="literal">MyClass1</code>
     e <code class="literal">MyClass2</code> dos arquivos <var class="filename">MyClass1.php</var>
     e <var class="filename">MyClass2.php</var>, respectivamente.
    </p></div>
    <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$class_name</span><span style="color: #007700">) {<br />    include </span><span style="color: #0000BB">$class_name </span><span style="color: #007700">. </span><span style="color: #DD0000">'.php'</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$obj  </span><span style="color: #007700">= new </span><span style="color: #0000BB">MyClass1</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">$obj2 </span><span style="color: #007700">= new </span><span style="color: #0000BB">MyClass2</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
   <div class="example" id="example-243">
    <p><strong>Exemplo #2 Outro exemplo de autocarregamento</strong></p>
    <div class="example-contents"><p>
     Este exemplo tenta carregar a interface <code class="literal">ITest</code>.
    </p></div>
    <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$name</span><span style="color: #007700">) {<br />    </span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$name</span><span style="color: #007700">);<br />});<br /><br />class </span><span style="color: #0000BB">Foo </span><span style="color: #007700">implements </span><span style="color: #0000BB">ITest </span><span style="color: #007700">{<br />}<br /><br /></span><span style="color: #FF8000">/*<br />string(5) "ITest"<br /><br />Fatal error: Interface 'ITest' not found in ...<br />*/<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
   <div class="example" id="example-244">
    <p><strong>Exemplo #3 Usando o autocarregador do Composer</strong></p>
    <div class="example-contents"><p>
     <a href="https://getcomposer.org/" class="link external">&raquo;&nbsp;Composer</a> gera um <code class="literal">vendor/autoload.php</code>
     que é configurado para carregar automaticamente pacotes gerenciados
     pelo Composer. Ao incluir este arquivo, esses pacotes podem ser usados sem
     nenhum trabalho adicional.
    </p></div>
    <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /></span><span style="color: #007700">require </span><span style="color: #0000BB">__DIR__ </span><span style="color: #007700">. </span><span style="color: #DD0000">'/vendor/autoload.php'</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$uuid </span><span style="color: #007700">= new </span><span style="color: #0000BB">Ramsey\Uuid\Uuid</span><span style="color: #007700">::</span><span style="color: #0000BB">uuid7</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Gerado novo UUID -&gt; "</span><span style="color: #007700">, </span><span style="color: #0000BB">$uuid</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">toString</span><span style="color: #007700">(), </span><span style="color: #DD0000">"\n"</span><span style="color: #007700">;<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
  </p>

  <div class="simplesect">
   <h3 class="title">Veja Também</h3>
   <p class="para">
    <ul class="simplelist">
     <li><span class="function"><a href="function.unserialize.php" class="function">unserialize()</a></span></li>
     <li><a href="var.configuration.php#ini.unserialize-callback-func" class="link">unserialize_callback_func</a></li>
     <li><a href="var.configuration.php#ini.unserialize-max-depth" class="link">unserialize_max_depth</a></li>
     <li><span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span></li>
     <li><span class="function"><a href="function.spl-autoload.php" class="function">spl_autoload()</a></span></li>
     <li><span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span></li>
    </ul>
   </p>
  </div>

 </div><?php manual_footer($setup); ?>